#!/bin/bash
set -ex

# see man flock "EXAMPLES"
[ "${FLOCKER}" != "$0" ] && exec env FLOCKER="$0" flock -enF "$0" "$0" "$@" || :

RT={{ metws_job_scripts | quote }}/util/rounded_times
FIMEX_VERIF={{ metws_job_scripts | quote }}/util/fimex-verif
FIMEX_VCROSS={{ metws_job_scripts | quote }}/util/fimex-vcross

ICON_SCRIPTS="$(dirname $0)"
ICON_WORK={{ dwd_icon_workdir | quote }}
ICON_DATA={{ dwd_icon_datadir | quote }}

INT={{ dwd_icon_reftime_interval | quote }}
DLY={{ dwd_icon_reftime_delay | quote }}
CNT={{ dwd_icon_reftime_count | quote }}

mkdir -p "$ICON_WORK" "$ICON_DATA"

# cleanup
AGE={{ dwd_icon_max_age_days | quote }}
find "$ICON_WORK" -maxdepth 1 -type d -name "20??????T??Z" -mtime "+$AGE" -exec rm -rf \{\} \;
find "$ICON_DATA" -type f -name "icon_????????T??Z.nc"      -mtime "+$AGE" -exec rm -vf \{\} \;
find "$ICON_DATA" -type f -name "icon_????????T??Z_vc.nc"   -mtime "+$AGE" -exec rm -vf \{\} \;
find "$ICON_DATA" -type f -name "icon_????????T??Z_vf.nc"   -mtime "+$AGE" -exec rm -vf \{\} \;


grb2nc() {
    GRB="$1" ; shift
    NCFILE="$1"; shift
    if test ! -f "$NCFILE" ; then
        fimex \
            --input.type grib2 \
            --input.file "$GRB" \
            --input.config "$ICON_SCRIPTS/IconGribReaderConfig.xml" \
            --output.type nc4 \
            --output.file "$NCFILE"
    fi

    "$FIMEX_VCROSS" "$NCFILE"
    "$FIMEX_VERIF"  "$NCFILE"
}

NCFILES=()
for TIME in `"$RT" --interval "$INT" --delay "$DLY" --count "$CNT"` ; do
    "$ICON_SCRIPTS/fetch_interpolate_icon" --workdir "$ICON_WORK" "$TIME"

    T=`date --utc '+%Y%m%dT%HZ' --date "$TIME"`
    NCFILE="$ICON_DATA/icon_$T.nc"
    grb2nc "glob:$ICON_WORK/$T/lonlat/*.grib2" "$NCFILE"
    NCFILES+=("$NCFILE")
done

MP={{ metws_job_scripts | quote }}/util/make_time_size_prom_file
if test -x "$MP" ; then
    "$MP" "devcoop_dwd_icon_latest" "latest ICON NetCDF file" "${NCFILES[@]}"
fi
